#include <bits/stdc++.h>
using namespace std;
int main(){
	ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
	int C,N,Q,slaveA,slaveB,WR=0,O=0;
	string k;
	cin>>N>>C>>Q>>k;
	for(int i=0;i<N;i++){
		if(k[i]=='1')WR++;
	}
	for(int i=0;i<Q;i++){
		cin>>slaveA>>slaveB;
		for(int j=slaveA-1;j<slaveB;j++){
				if(k[j]=='0'){
				WR++;k[j]='1';
			}
				else {
				k[j]='0';WR--;	
			}
		}
		cout<<WR<<"\n";
	}
	return 0;
}